-- Craft Research Timer (CRT) by @aTo (EU)
-- v0.4.8


function CRT_Collect_Data(playername)	
	CRT_Info_Research(CRAFTING_TYPE_BLACKSMITHING, 0, playername)
	CRT_Info_Research(CRAFTING_TYPE_CLOTHIER, 1, playername)
	CRT_Info_Research(CRAFTING_TYPE_WOODWORKING, 2, playername)
end


function CRT_Info_Research(craft_type,id_craft,playername)
	local Simu_craft = 0
	local MaxResearch = GetMaxSimultaneousSmithingResearch(craft_type)
	local nbtype = GetNumSmithingResearchLines(craft_type) --Nombre de item craftable pour un craft(ex couture: jambe/robe/ect)
	
	CRT.SV.Craft_data[playername][id_craft] = {}
	
	for ResearchLines = 1, nbtype, 1 do
		local item_name, item_icon, numTraits, timeRequiredForNextResearchSecs = GetSmithingResearchLineInfo(craft_type, ResearchLines)
		for ResearchTrait = 1, numTraits, 1 do
			local duration, timeRemaining = GetSmithingResearchLineTraitTimes(craft_type, ResearchLines, ResearchTrait) 
		
			if (duration ~= nil and timeRemaining ~= nil) then
				
				Simu_craft = Simu_craft + 1
			
			
			local traitType, trait_description, _ = GetSmithingResearchLineTraitInfo(craft_type,ResearchLines,ResearchTrait)
			local _, trait_name, trait_icon, _, _, _, _ = GetSmithingTraitItemInfo(traitType+1)

			
			
			CRT.SV.Craft_data[playername][id_craft][Simu_craft] = {}
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["PlayerName"] = playername
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["Alert"] = true
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["EndTimeStamp"] = GetTimeStamp() + timeRemaining
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["Item_name"] = string.sub(item_name, 1, 18)
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["Item_icon"] = item_icon
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["Trait_name"] = trait_name
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["Trait_icon"] = trait_icon
			CRT.SV.Craft_data[playername][id_craft][Simu_craft]["Trait_description"] = trait_description
				
				--	d("Type de craft :"..id_craft.." nom de l'item :"..name.." temps restant :"..temp_timer[Simu_craft])
			end
		end
	end
	CRT.SV.Craft_data[playername][id_craft]["MaxResearch"] = MaxResearch
	CRT.SV.Craft_data[playername][id_craft]["Simu_craft"] = Simu_craft
end	

function CRT_Research_started()
		
		local playername = GetUnitName("player") 
		-- erase all data for this character
		CRT.SV.Craft_data[playername] = {}
		-- Collect new data
		CRT_Collect_Data(playername)	
		
		if (CRT_GRID_TLW == nil) then
			CRT_GRID_Create()
		end
		if (CRT_GRID_WD[playername] == nil) then
			CRT_GRID_Create_Character(playername)
		end
end